#ifndef __CIF_BTS__
#define __CIF_BTS__
// Basic Text Support (BTS)

#include "Windows.h"


#define CIFAPI _stdcall
//#define CIFAPI 

//String Memory Management
LPSTR CIFAPI AnsiStringAllocate(DWORD nSize);
VOID  CIFAPI AnsiStringFree(LPSTR lpstr);
LPWSTR CIFAPI UnicodeStringAllocate(DWORD nSize);
VOID  CIFAPI UnicodeStringFree(LPWSTR lpstr);

DWORD CIFAPI AnsiStringLength(LPCSTR lpstr);
DWORD CIFAPI UnicodeStringLength(LPCWSTR lpstr);
LPSTR CIFAPI AnsiStringUpperCase(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringUpperCase(LPCWSTR lpstr);
LPSTR CIFAPI AnsiStringLowerCase(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringLowerCase(LPCWSTR lpstr);

LPSTR CIFAPI AnsiStringFromUnicode(LPCWSTR lpstr);
LPSTR CIFAPI AnsiStringFromUnicodeEx(LPCWSTR lpstr,LPBOOL lpUsedDefaultChar);
LPWSTR CIFAPI UnicodeStringFromAnsi(LPCSTR lpstr);

//Ansi number to string
LPSTR CIFAPI AnsiStringFromInt8(CONST CHAR & n);
LPSTR CIFAPI AnsiStringFromUInt8(CONST UCHAR & n);
LPSTR CIFAPI AnsiStringFromInt16(CONST SHORT & n);
LPSTR CIFAPI AnsiStringFromUInt16(CONST WORD & n);
LPSTR CIFAPI AnsiStringFromInt32(CONST LONG & n);
LPSTR CIFAPI AnsiStringFromUInt32(CONST DWORD & n);
LPSTR CIFAPI AnsiStringFromFloat(CONST FLOAT & n);
LPSTR CIFAPI AnsiStringFromDouble(CONST double & n);
LPSTR CIFAPI AnsiStringFromFloatEx(CONST FLOAT & n,CONST INT & nPrecision);
LPSTR CIFAPI AnsiStringFromDoubleEx(CONST double & n,CONST INT & nPrecision);

//Unicode number to string
LPWSTR CIFAPI UnicodeStringFromInt8(CONST CHAR & n);
LPWSTR CIFAPI UnicodeStringFromUInt8(CONST UCHAR & n);
LPWSTR CIFAPI UnicodeStringFromInt16(CONST SHORT & n);
LPWSTR CIFAPI UnicodeStringFromUInt16(CONST WORD & n);
LPWSTR CIFAPI UnicodeStringFromInt32(CONST LONG & n);
LPWSTR CIFAPI UnicodeStringFromUInt32(CONST DWORD & n);
LPWSTR CIFAPI UnicodeStringFromFloat(CONST FLOAT & n);
LPWSTR CIFAPI UnicodeStringFromDouble(CONST double & n);
LPWSTR CIFAPI UnicodeStringFromFloatEx(CONST FLOAT & n,CONST INT & nPrecision);
LPWSTR CIFAPI UnicodeStringFromDoubleEx(CONST double & n,CONST INT & nPrecision);
// String to number crt
LONG AnsiStringHexToInt32(LPCSTR lpstr);
DWORD AnsiStringHexToUInt32(LPCSTR lpstr);
LONG AnsiStringToInt32(LPCSTR lpstr);
DWORD AnsiStringToUInt32(LPCSTR lpstr);
double AnsiStringToDouble(LPCSTR lpstr);
LONG UnicodeStringHexToInt32(LPCWSTR lpstr);
DWORD UnicodeStringHexToUInt32(LPCWSTR lpstr);
LONG UnicodeStringToInt32(LPCWSTR lpstr);
DWORD UnicodeStringToUInt32(LPCWSTR lpstr);
double UnicodeStringToDouble(LPCWSTR lpstr);
// String to number extra
CHAR UnicodeStringToInt8(LPCWSTR lpstr);
UCHAR UnicodeStringToUInt8(LPCWSTR lpstr);
SHORT UnicodeStringToInt16(LPCWSTR lpstr);
WORD UnicodeStringToUInt16(LPCWSTR lpstr);
FLOAT UnicodeStringToFloat(LPCWSTR lpstr);
CHAR AnsiStringToInt8(LPCSTR lpstr);
UCHAR AnsiStringToUInt8(LPCSTR lpstr);
SHORT AnsiStringToInt16(LPCSTR lpstr);
WORD AnsiStringToUInt16(LPCSTR lpstr);
FLOAT AnsiStringToFloat(LPCSTR lpstr);

//Trim
LPSTR CIFAPI AnsiStringTrim(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringTrim(LPCWSTR lpstr);
LPSTR CIFAPI AnsiStringTrimRight(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringTrimRight(LPCWSTR lpstr);
LPSTR CIFAPI AnsiStringTrimLeft(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringTrimLeft(LPCWSTR lpstr);

typedef BOOL (CALLBACK* ANSITRIMIT)(CHAR);
typedef BOOL (CALLBACK* UNCODETRIMIT)(WCHAR);
LPSTR CIFAPI AnsiStringTrimEx(LPCSTR lpstr,ANSITRIMIT lpTrimIt);
LPWSTR CIFAPI UnicodeStringTrimEx(LPCWSTR lpstr,UNCODETRIMIT lpTrimIt);
LPSTR CIFAPI AnsiStringTrimRightEx(LPCSTR lpstr,ANSITRIMIT lpTrimIt);
LPWSTR CIFAPI UnicodeStringTrimRightEx(LPCWSTR lpstr,UNCODETRIMIT lpTrimIt);
LPSTR CIFAPI AnsiStringTrimLeftEx(LPCSTR lpstr,ANSITRIMIT lpTrimIt);
LPWSTR CIFAPI UnicodeStringTrimLeftEx(LPCWSTR lpstr,UNCODETRIMIT lpTrimIt);

LPSTR CIFAPI AnsiStringReverse(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringReverse(LPCWSTR lpstr);

// Padding a String
LPSTR CIFAPI AnsiStringPad(LPCSTR lpstr,CHAR ch,DWORD nSize);
LPWSTR CIFAPI UnicodeStringPad(LPCWSTR lpstr,WCHAR wch,DWORD nSize); 

//Extracting a File Extension from a String
//LPSTR CIFAPI AnsiStringGetFileExt(LPCSTR lpFileName);
//LPWSTR CIFAPI UnicodeStringGetFileExt(LPCWSTR lpFileName);
//Replacing a File Extension
//LPSTR CIFAPI AnsiStringReplaceFileExt(LPCSTR lpFileName,LPCSTR lpNewExt);
//LPWSTR CIFAPI UnicodeStringReplaceFileExt(LPCWSTR lpFileName,LPCWSTR lpNewExt);

//Copy Append
LPSTR CIFAPI AnsiStringCopy(LPCSTR lpstr);
LPWSTR CIFAPI UnicodeStringCopy(LPCWSTR lpstr);
LPSTR CIFAPI AnsiStringAppend(LPCSTR lpstr1,LPCSTR lpstr2);
LPWSTR CIFAPI UnicodeStringAppend(LPCWSTR lpstr1,LPCWSTR lpstr2);
//BASIC Like Function
LPSTR CIFAPI AnsiStringRight(LPCSTR lpstr,DWORD nSize);
LPWSTR CIFAPI UnicodeStringRight(LPCWSTR lpstr,DWORD nSize);
LPSTR CIFAPI AnsiStringLeft(LPCSTR lpstr,DWORD nSize);
LPWSTR CIFAPI UnicodeStringLeft(LPCWSTR lpstr,DWORD nSize);
LPSTR CIFAPI AnsiStringMid(LPCSTR lpstr,DWORD nStart);
LPWSTR CIFAPI UnicodeStringMid(LPCWSTR lpstr,DWORD nStart);
LPSTR CIFAPI AnsiStringMidEx(LPCSTR lpstr,DWORD nStart,DWORD nSize);
LPWSTR CIFAPI UnicodeStringMidEx(LPCWSTR lpstr,DWORD nStart,DWORD nSize);
LPSTR CIFAPI AnsiStringFill(CHAR c,DWORD nCount);
LPWSTR CIFAPI UnicodeStringFill(WCHAR c,DWORD nCount);
DWORD CIFAPI AnsiStringInStr(DWORD nStartPosition,LPCSTR lpstr,LPCSTR lpfindstr);
DWORD CIFAPI UnicodeStringInStr(DWORD nStartPosition,LPCWSTR lpstr,LPCWSTR lpfindstr);

//Compare
BOOL CIFAPI UnicodeStringIsEqualsNoCase(LPCWSTR lpstr1,LPCWSTR lpstr2);
BOOL CIFAPI AnsiStringIsEqualsNoCase(LPCSTR lpstr1,LPCSTR lpstr2);
BOOL CIFAPI UnicodeStringIsEquals(LPCWSTR lpstr1,LPCWSTR lpstr2);
BOOL CIFAPI AnsiStringIsEquals(LPCSTR lpstr1,LPCSTR lpstr2);

LPSTR CIFAPI AnsiStringInsert(LPCSTR lpstr,DWORD nStart,LPCSTR lpnewstr);
LPWSTR CIFAPI UnicodeStringInsert(LPCWSTR lpstr,DWORD nStart,LPCWSTR lpnewstr);
LPSTR CIFAPI AnsiStringDelete(LPCSTR lpstr,DWORD nStart,DWORD nSize);
LPWSTR CIFAPI UnicodeStringDelete(LPCWSTR lpstr,DWORD nStart,DWORD nSize);
LPSTR CIFAPI AnsiStringChr(CHAR ch);
LPWSTR CIFAPI UnicodeStringChr(WCHAR ch);

DWORD CIFAPI AnsiStringFindEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI  AnsiStringFindNoCaseEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI AnsiStringFind(LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI AnsiStringFindNoCase(LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI UnicodeStringFindEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringFindNoCaseEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringFind(LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringFindNoCase(LPCWSTR lpsz,LPCWSTR lpszFind);

BOOL CIFAPI UnicodeStringIsEqualsNoCaseEx(LPCWSTR lpstr1,LPCWSTR lpstr2,DWORD nSize);
BOOL CIFAPI AnsiStringIsEqualsNoCaseEx(LPCSTR lpstr1,LPCSTR lpstr2,DWORD nSize);
BOOL CIFAPI UnicodeStringIsEqualsEx(LPCWSTR lpstr1,LPCWSTR lpstr2,DWORD nSize);
BOOL CIFAPI AnsiStringIsEqualsEx(LPCSTR lpstr1,LPCSTR lpstr2,DWORD nSize);
DWORD CIFAPI AnsiStringFindReverseEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI AnsiStringFindReverseNoCaseEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI AnsiStringFindReverse(LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI AnsiStringFindReverseNoCase(LPCSTR lpsz,LPCSTR lpszFind);
DWORD CIFAPI UnicodeStringFindReverseEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringFindReverseNoCaseEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringFindReverse(LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringFindReverseNoCase(LPCWSTR lpsz,LPCWSTR lpszFind);
DWORD CIFAPI UnicodeStringInStrRev(DWORD nStartPosition,LPCWSTR lpstr,LPCWSTR lpfindstr);
DWORD CIFAPI AnsiStringInStrRev(DWORD nStartPosition,LPCSTR lpstr,LPCSTR lpfindstr);

DWORD CIFAPI AnsiStringFindOneOf(LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindNotOneOf(LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindOneOfEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindNotOneOfEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindReverseOneOf(LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindReverseNotOneOf(LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindReverseOneOfEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpCharSet);
DWORD CIFAPI AnsiStringFindReverseNotOneOfEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpCharSet);

DWORD CIFAPI UnicodeStringFindOneOf(LPCWSTR lpsz,LPCWSTR lpCharSet);
DWORD CIFAPI UnicodeStringFindNotOneOf(LPCWSTR lpsz,LPCWSTR lpCharSet);
DWORD CIFAPI UnicodeStringFindOneOfEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpCharSet);
DWORD CIFAPI UnicodeStringFindNotOneOfEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpCharSet);

DWORD CIFAPI UnicodeStringFindReverseOneOf(LPCWSTR lpsz,LPCWSTR lpCharSet);
DWORD CIFAPI UnicodeStringFindReverseNotOneOf(LPCWSTR lpsz,LPCWSTR lpCharSet);
DWORD CIFAPI UnicodeStringFindReverseOneOfEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpCharSet);
DWORD CIFAPI UnicodeStringFindReverseNotOneOfEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpCharSet);

DWORD CIFAPI AnsiStringFindChar(LPCSTR lpsz,CHAR ch);
DWORD CIFAPI AnsiStringFindCharNoCase(LPCSTR lpsz,CHAR ch);
DWORD CIFAPI AnsiStringFindCharEx(DWORD nStart,LPCSTR lpsz,CHAR ch);
DWORD CIFAPI AnsiStringFindCharNoCaseEx(DWORD nStart,LPCSTR lpsz,CHAR ch);

DWORD CIFAPI AnsiStringFindCharReverse(LPCSTR lpsz,CHAR ch);
DWORD CIFAPI AnsiStringFindCharReverseNoCase(LPCSTR lpsz,CHAR ch);
DWORD CIFAPI AnsiStringFindCharReverseEx(DWORD nStart,LPCSTR lpsz,CHAR ch);
DWORD CIFAPI AnsiStringFindCharReverseNoCaseEx(DWORD nStart,LPCSTR lpsz,CHAR ch);

DWORD CIFAPI UnicodeStringFindChar(LPCWSTR lpsz,WCHAR ch);
DWORD CIFAPI UnicodeStringFindCharNoCase(LPCWSTR lpsz,WCHAR ch);
DWORD CIFAPI UnicodeStringFindCharEx(DWORD nStart,LPCWSTR lpsz,WCHAR ch);
DWORD CIFAPI UnicodeStringFindCharNoCaseEx(DWORD nStart,LPCWSTR lpsz,WCHAR ch);

DWORD CIFAPI UnicodeStringFindCharReverse(LPCWSTR lpsz,WCHAR ch);
DWORD CIFAPI UnicodeStringFindCharReverseNoCase(LPCWSTR lpsz,WCHAR ch);
DWORD CIFAPI UnicodeStringFindCharReverseEx(DWORD nStart,LPCWSTR lpsz,WCHAR ch);
DWORD CIFAPI UnicodeStringFindCharReverseNoCaseEx(DWORD nStart,LPCWSTR lpsz,WCHAR ch);

DWORD CIFAPI AnsiStringFindCount(LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindCountNoCase(LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindCountEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindCountNoCaseEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpFind);

DWORD CIFAPI AnsiStringFindCharCount(LPCSTR lpsz,CHAR chFind);
DWORD CIFAPI AnsiStringFindCharCountNoCase(LPCSTR lpsz,CHAR chFind);
DWORD CIFAPI AnsiStringFindCharCountEx(DWORD nStart,LPCSTR lpsz,CHAR chFind);
DWORD CIFAPI AnsiStringFindCharCountNoCaseEx(DWORD nStart,LPCSTR lpsz,CHAR chFind);

DWORD CIFAPI UnicodeStringFindCount(LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindCountNoCase(LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindCountEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindCountNoCaseEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpFind);

DWORD CIFAPI UnicodeStringFindCharCount(LPCWSTR lpsz,WCHAR chFind);
DWORD CIFAPI UnicodeStringFindCharCountNoCase(LPCWSTR lpsz,WCHAR chFind);
DWORD CIFAPI UnicodeStringFindCharCountEx(DWORD nStart,LPCWSTR lpsz,WCHAR chFind);
DWORD CIFAPI UnicodeStringFindCharCountNoCaseEx(DWORD nStart,LPCWSTR lpsz,WCHAR chFind);

DWORD CIFAPI AnsiStringFindNth(DWORD nNth,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindNthNoCase(DWORD nNth,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindNthEx(DWORD nNth,DWORD nStart,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindNthNoCaseEx(DWORD nNth,DWORD nStart,LPCSTR lpsz,LPCSTR lpFind);

DWORD CIFAPI AnsiStringFindReverseNth(DWORD nNth,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindReverseNthNoCase(DWORD nNth,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindReverseNthEx(DWORD nNth,DWORD nStart,LPCSTR lpsz,LPCSTR lpFind);
DWORD CIFAPI AnsiStringFindReverseNthNoCaseEx(DWORD nNth,DWORD nStart,LPCSTR lpsz,LPCSTR lpFind);

DWORD CIFAPI UnicodeStringFindNth(DWORD nNth,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindNthNoCase(DWORD nNth,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindNthEx(DWORD nNth,DWORD nStart,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindNthNoCaseEx(DWORD nNth,DWORD nStart,LPCWSTR lpsz,LPCWSTR lpFind);

DWORD CIFAPI UnicodeStringFindReverseNth(DWORD nNth,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindReverseNthNoCase(DWORD nNth,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindReverseNthEx(DWORD nNth,DWORD nStart,LPCWSTR lpsz,LPCWSTR lpFind);
DWORD CIFAPI UnicodeStringFindReverseNthNoCaseEx(DWORD nNth,DWORD nStart,LPCWSTR lpsz,LPCWSTR lpFind);

LPSTR CIFAPI AnsiStringSwitchCase(LPCSTR lpsz);
LPSTR CIFAPI AnsiStringInsertChar(LPCSTR lpsz,DWORD nStart,CHAR ch);
LPSTR CIFAPI AnsiStringAppendChar(LPCSTR lpsz,CHAR ch);
LPSTR CIFAPI AnsiStringPrependChar(LPCSTR lpsz,CHAR ch);
LPSTR CIFAPI AnsiStringTrimChar(LPCSTR lpsz,CHAR ch); 
LPSTR CIFAPI AnsiStringTrimLeftChar(LPCSTR lpsz,CHAR ch);
LPSTR CIFAPI AnsiStringTrimRightChar(LPCSTR lpsz,CHAR ch); 
LPSTR CIFAPI AnsiStringTrimCharSet(LPCSTR lpsz,LPCSTR lpCharSet);
LPSTR CIFAPI AnsiStringTrimLeftCharSet(LPCSTR lpsz,LPCSTR lpCharSet);
LPSTR CIFAPI AnsiStringTrimRightCharSet(LPCSTR lpsz,LPCSTR lpCharSet);

LPWSTR CIFAPI UnicodeStringSwitchCase(LPCWSTR lpsz);
LPWSTR CIFAPI UnicodeStringInsertChar(LPCWSTR lpsz,DWORD nStart,CHAR ch);
LPWSTR CIFAPI UnicodeStringAppendChar(LPCWSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringPrependChar(LPCWSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringTrimChar(LPCWSTR lpsz,CHAR ch); 
LPWSTR CIFAPI UnicodeStringTrimLeftChar(LPCWSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringTrimRightChar(LPCWSTR lpsz,CHAR ch); 
LPWSTR CIFAPI UnicodeStringTrimCharSet(LPCWSTR lpsz,LPCWSTR lpCharSet);
LPWSTR CIFAPI UnicodeStringTrimLeftCharSet(LPCWSTR lpsz,LPCWSTR lpCharSet);
LPWSTR CIFAPI UnicodeStringTrimRightCharSet(LPCWSTR lpsz,LPCWSTR lpCharSet);

BOOL CIFAPI AnsiStringIsStartWith(LPCSTR lpsz,LPCSTR lprhs) ;
BOOL CIFAPI AnsiStringIsEndWith(LPCSTR lpsz,LPCSTR lprhs) ;
BOOL CIFAPI AnsiStringIsStartWithNoCase(LPCSTR lpsz,LPCSTR lprhs) ;
BOOL CIFAPI AnsiStringIsEndWithNoCase(LPCSTR lpsz,LPCSTR lprhs) ;

BOOL CIFAPI UnicodeStringIsStartWith(LPCWSTR lpsz,LPCWSTR lprhs) ;
BOOL CIFAPI UnicodeStringIsEndWith(LPCWSTR lpsz,LPCWSTR lprhs) ;
BOOL CIFAPI UnicodeStringIsStartWithNoCase(LPCWSTR lpsz,LPCWSTR lprhs) ;
BOOL CIFAPI UnicodeStringIsEndWithNoCase(LPCWSTR lpsz,LPCWSTR lprhs) ;

LPSTR CIFAPI AnsiStringReplaceChar(LPCSTR lpsz,CHAR chOld,CHAR chNew);
LPSTR CIFAPI AnsiStringReplaceCharEx(DWORD nStart,LPCSTR lpsz,CHAR chOld,CHAR chNew);	
LPSTR CIFAPI AnsiStringReplaceCharNoCase(LPCSTR lpsz,CHAR chOld,CHAR chNew);
LPSTR CIFAPI AnsiStringReplaceCharNoCaseEx(DWORD nStart,LPCSTR lpsz,CHAR chOld,CHAR chNew);		
		

LPWSTR CIFAPI UnicodeStringReplaceChar(LPCWSTR lpsz,WCHAR chOld,WCHAR chNew);
LPWSTR CIFAPI UnicodeStringReplaceCharEx(DWORD nStart,LPCWSTR lpsz,WCHAR chOld,WCHAR chNew);	
LPWSTR CIFAPI UnicodeStringReplaceCharNoCase(LPCWSTR lpsz,WCHAR chOld,WCHAR chNew);
LPWSTR CIFAPI UnicodeStringReplaceCharNoCaseEx(DWORD nStart,LPCWSTR lpsz,WCHAR chOld,WCHAR chNew);		

LPSTR CIFAPI AnsiStringReplace(LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );
LPSTR CIFAPI AnsiStringReplaceEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );	
LPSTR CIFAPI AnsiStringReplaceNoCase(LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );
LPSTR CIFAPI AnsiStringReplaceNoCaseEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );
LPSTR CIFAPI AnsiStringAppendEx(LPCSTR lpstr1,LPCSTR lpstr2,DWORD nSize);
LPSTR CIFAPI AnsiStringRemove(LPCSTR lpsz,LPCSTR lpszFind);
LPSTR CIFAPI AnsiStringRemoveEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszFind);
LPSTR CIFAPI AnsiStringRemoveNoCase(LPCSTR lpsz,LPCSTR lpszFind);
LPSTR CIFAPI AnsiStringRemoveNoCaseEx(DWORD nStart,LPCSTR lpsz,LPCSTR lpszFind);

LPWSTR CIFAPI UnicodeStringReplace(LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );
LPWSTR CIFAPI UnicodeStringReplaceEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );	
LPWSTR CIFAPI UnicodeStringReplaceNoCase(LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );
LPWSTR CIFAPI UnicodeStringReplaceNoCaseEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );
LPWSTR CIFAPI UnicodeStringAppendEx(LPCWSTR lpstr1,LPCWSTR lpstr2,DWORD nSize);
LPWSTR CIFAPI UnicodeStringRemove(LPCWSTR lpsz,LPCWSTR lpszFind);
LPWSTR CIFAPI UnicodeStringRemoveEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszFind);
LPWSTR CIFAPI UnicodeStringRemoveNoCase(LPCWSTR lpsz,LPCWSTR lpszFind);
LPWSTR CIFAPI UnicodeStringRemoveNoCaseEx(DWORD nStart,LPCWSTR lpsz,LPCWSTR lpszFind);

LPSTR CIFAPI AnsiStringRemoveChar(LPCSTR lpsz,CHAR ch);
LPSTR CIFAPI AnsiStringRemoveCharEx(DWORD nStart,LPCSTR lpsz,CHAR ch);
LPSTR CIFAPI AnsiStringRemoveCharNoCase(LPCSTR lpsz,CHAR ch);
LPSTR CIFAPI AnsiStringRemoveCharNoCaseEx(DWORD nStart,LPCSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringRemoveChar(LPCWSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringRemoveCharEx(DWORD nStart,LPCWSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringRemoveCharNoCase(LPCWSTR lpsz,CHAR ch);
LPWSTR CIFAPI UnicodeStringRemoveCharNoCaseEx(DWORD nStart,LPCWSTR lpsz,CHAR ch);


LPSTR CIFAPI AnsiStringReplaceCounted(DWORD nCount,LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );
LPSTR CIFAPI AnsiStringReplaceCountedEx(DWORD nStart,DWORD nCount,LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );	
LPSTR CIFAPI AnsiStringReplaceCountedNoCase(DWORD nCount,LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );
LPSTR CIFAPI AnsiStringReplaceCountedNoCaseEx(DWORD nStart,DWORD nCount,LPCSTR lpsz,LPCSTR lpszOld,LPCSTR lpszNew );
LPWSTR CIFAPI UnicodeStringReplaceCounted(DWORD nCount,LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );
LPWSTR CIFAPI UnicodeStringReplaceCountedEx(DWORD nStart,DWORD nCount,LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );	
LPWSTR CIFAPI UnicodeStringReplaceCountedNoCase(DWORD nCount,LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );
LPWSTR CIFAPI UnicodeStringReplaceCountedNoCaseEx(DWORD nStart,DWORD nCount,LPCWSTR lpsz,LPCWSTR lpszOld,LPCWSTR lpszNew );

LPSTR AnsiStringReplaceAt(LPCSTR lpsz,DWORD nStart,DWORD nSize,LPCSTR lpszNew);
LPWSTR UnicodeStringReplaceAt(LPCWSTR lpsz,DWORD nStart,DWORD nSize,LPCWSTR lpszNew);

#endif


/*//------------------------------------------------------------
This Software/Project/Code Developed By Muhammad Arshad Latti.
Location: Sargodha (Pakistan) arshadlatti@gmail.com
http://arshadlatti.angelfire.com
*///------------------------------------------------------------
